"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.emailProviderDefaults = emailProviderDefaults;
exports.phoneProviderDefaults = phoneProviderDefaults;
// eslint-disable-next-line import/prefer-default-export
function emailProviderDefaults(emailProvider) {
    // eslint-disable-line
    const updated = Object.assign({}, emailProvider);
    const apiKeyProviders = ['mailgun', 'mandrill', 'sendgrid', 'sparkpost'];
    // Add placeholder for credentials as they cannot be exported
    const { name } = updated;
    if (apiKeyProviders.includes(name)) {
        updated.credentials = Object.assign({ api_key: `##${name.toUpperCase()}_API_KEY##` }, (updated.credentials || {}));
    }
    if (name === 'smtp') {
        updated.credentials = Object.assign({ smtp_host: '##SMTP_HOSTNAME##', smtp_port: '##SMTP_PORT##', smtp_user: '##SMTP_USER##', smtp_pass: '##SMTP_PASS##' }, (updated.credentials || {}));
    }
    if (name === 'ses') {
        updated.credentials = Object.assign({ accessKeyId: '##SES_ACCESS_KEY_ID##', secretAccessKey: '##SES_ACCESS_SECRET_KEY##', region: '##SES_AWS_REGION##' }, (updated.credentials || {}));
    }
    if (name === 'azure_cs') {
        updated.credentials = Object.assign({ connectionString: '##AZURE_CS_CONNECTION_KEY##' }, (updated.credentials || {}));
    }
    if (name === 'ms365') {
        updated.credentials = Object.assign({ tenantId: '##MS365_TENANT_ID##', clientId: '##MS365_CLIENT_ID##', clientSecret: '##MS365_CLIENT_SECRET##' }, (updated.credentials || {}));
    }
    return updated;
}
function phoneProviderDefaults(phoneProvider) {
    const updated = Object.assign({}, phoneProvider);
    const removeKeysFromOutput = [
        'id',
        'created_at',
        'updated_at',
        'channel',
        'tenant',
        'credentials',
    ];
    removeKeysFromOutput.forEach((key) => {
        if (key in updated) {
            delete updated[key];
        }
    });
    const apiKeyProviders = ['twilio'];
    // Add placeholder for credentials as they cannot be exported
    const { name } = updated;
    if (apiKeyProviders.includes(name)) {
        updated.credentials = {
            auth_token: `##${name.toUpperCase()}_AUTH_TOKEN##`,
        };
    }
    return updated;
}
//# sourceMappingURL=defaults.js.map