"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = __importDefault(require("path"));
const fs_extra_1 = __importDefault(require("fs-extra"));
const tools_1 = require("../../../tools");
const utils_1 = require("../../../utils");
function parse(context) {
    const guardianFolder = path_1.default.join(context.filePath, tools_1.constants.GUARDIAN_DIRECTORY);
    if (!(0, utils_1.existsMustBeDir)(guardianFolder))
        return { guardianPhoneFactorMessageTypes: null }; // Skip
    const file = path_1.default.join(guardianFolder, 'phoneFactorMessageTypes.json');
    if (!(0, utils_1.isFile)(file)) {
        return { guardianPhoneFactorMessageTypes: null };
    }
    return {
        guardianPhoneFactorMessageTypes: (0, utils_1.loadJSON)(file, {
            mappings: context.mappings,
            disableKeywordReplacement: context.disableKeywordReplacement,
        }),
    };
}
function dump(context) {
    return __awaiter(this, void 0, void 0, function* () {
        const { guardianPhoneFactorMessageTypes } = context.assets;
        if (!guardianPhoneFactorMessageTypes)
            return; // Skip, nothing to dump
        const guardianFolder = path_1.default.join(context.filePath, tools_1.constants.GUARDIAN_DIRECTORY);
        fs_extra_1.default.ensureDirSync(guardianFolder);
        const file = path_1.default.join(guardianFolder, 'phoneFactorMessageTypes.json');
        (0, utils_1.dumpJSON)(file, guardianPhoneFactorMessageTypes);
    });
}
const guardianFactorMessageTypesHandler = {
    parse,
    dump,
};
exports.default = guardianFactorMessageTypesHandler;
//# sourceMappingURL=guardianPhoneFactorMessageTypes.js.map