"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const pages_1 = __importDefault(require("./pages"));
const clients_1 = __importDefault(require("./clients"));
const tenant_1 = __importDefault(require("./tenant"));
const emailProvider_1 = __importDefault(require("./emailProvider"));
const connections_1 = __importDefault(require("./connections"));
const databases_1 = __importDefault(require("./databases"));
const emailTemplates_1 = __importDefault(require("./emailTemplates"));
const clientGrants_1 = __importDefault(require("./clientGrants"));
const resourceServers_1 = __importDefault(require("./resourceServers"));
const guardianFactors_1 = __importDefault(require("./guardianFactors"));
const guardianFactorProviders_1 = __importDefault(require("./guardianFactorProviders"));
const guardianFactorTemplates_1 = __importDefault(require("./guardianFactorTemplates"));
const guardianPhoneFactorMessageTypes_1 = __importDefault(require("./guardianPhoneFactorMessageTypes"));
const guardianPhoneFactorSelectedProvider_1 = __importDefault(require("./guardianPhoneFactorSelectedProvider"));
const guardianPolicies_1 = __importDefault(require("./guardianPolicies"));
const roles_1 = __importDefault(require("./roles"));
const actions_1 = __importDefault(require("./actions"));
const organizations_1 = __importDefault(require("./organizations"));
const triggers_1 = __importDefault(require("./triggers"));
const attackProtection_1 = __importDefault(require("./attackProtection"));
const branding_1 = __importDefault(require("./branding"));
const phoneProvider_1 = __importDefault(require("./phoneProvider"));
const logStreams_1 = __importDefault(require("./logStreams"));
const prompts_1 = __importDefault(require("./prompts"));
const customDomains_1 = __importDefault(require("./customDomains"));
const themes_1 = __importDefault(require("./themes"));
const rules_1 = __importDefault(require("./rules"));
const hooks_1 = __importDefault(require("./hooks"));
const rulesConfigs_1 = __importDefault(require("./rulesConfigs"));
const forms_1 = __importDefault(require("./forms"));
const flows_1 = __importDefault(require("./flows"));
const flowVaultConnections_1 = __importDefault(require("./flowVaultConnections"));
const networkACLs_1 = __importDefault(require("./networkACLs"));
const selfServiceProfiles_1 = __importDefault(require("./selfServiceProfiles"));
const directoryHandlers = {
    rules: rules_1.default,
    rulesConfigs: rulesConfigs_1.default,
    hooks: hooks_1.default,
    pages: pages_1.default,
    databases: databases_1.default,
    clientGrants: clientGrants_1.default,
    resourceServers: resourceServers_1.default,
    clients: clients_1.default,
    connections: connections_1.default,
    tenant: tenant_1.default,
    emailProvider: emailProvider_1.default,
    emailTemplates: emailTemplates_1.default,
    guardianFactors: guardianFactors_1.default,
    guardianFactorProviders: guardianFactorProviders_1.default,
    guardianFactorTemplates: guardianFactorTemplates_1.default,
    guardianPhoneFactorMessageTypes: guardianPhoneFactorMessageTypes_1.default,
    guardianPhoneFactorSelectedProvider: guardianPhoneFactorSelectedProvider_1.default,
    guardianPolicies: guardianPolicies_1.default,
    roles: roles_1.default,
    actions: actions_1.default,
    organizations: organizations_1.default,
    triggers: triggers_1.default,
    attackProtection: attackProtection_1.default,
    branding: branding_1.default,
    phoneProviders: phoneProvider_1.default,
    logStreams: logStreams_1.default,
    prompts: prompts_1.default,
    customDomains: customDomains_1.default,
    themes: themes_1.default,
    forms: forms_1.default,
    flows: flows_1.default,
    flowVaultConnections: flowVaultConnections_1.default,
    selfServiceProfiles: selfServiceProfiles_1.default,
    networkACLs: networkACLs_1.default,
};
exports.default = directoryHandlers;
//# sourceMappingURL=index.js.map