import { ManagementClient } from 'auth0';
import { Assets, Auth0APIClient, Config } from '../../types';
type KeywordMappings = {
    [key: string]: (string | number)[] | string | number;
};
export default class DirectoryContext {
    basePath: string;
    filePath: string;
    config: Config;
    mappings: KeywordMappings;
    mgmtClient: Auth0APIClient;
    assets: Assets;
    disableKeywordReplacement: boolean;
    constructor(config: Config, mgmtClient: ManagementClient);
    loadFile(f: string, folder: string): string;
    loadAssetsFromLocal(opts?: {
        disableKeywordReplacement: boolean;
    }): Promise<void>;
    dump(): Promise<void>;
}
export {};
