"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const logger_1 = __importDefault(require("../../../logger"));
function parse(context) {
    return __awaiter(this, void 0, void 0, function* () {
        const { networkACLs } = context.assets;
        if (!networkACLs)
            return { networkACLs: null };
        return {
            networkACLs,
        };
    });
}
function dump(context) {
    return __awaiter(this, void 0, void 0, function* () {
        let { networkACLs } = context.assets;
        if (!networkACLs)
            return { networkACLs: null };
        if (Array.isArray(networkACLs) && networkACLs.length === 0) {
            logger_1.default.info('No network ACLs available, skipping dump');
            return { networkACLs: null };
        }
        const removeKeysFromOutput = ['created_at', 'updated_at'];
        networkACLs = networkACLs.map((networkACL) => {
            removeKeysFromOutput.forEach((key) => {
                if (key in networkACL) {
                    delete networkACL[key];
                }
            });
            return networkACL;
        });
        return {
            networkACLs,
        };
    });
}
const networkACLsHandler = {
    parse,
    dump,
};
exports.default = networkACLsHandler;
//# sourceMappingURL=networkACLs.js.map