"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
function parse(context) {
    return __awaiter(this, void 0, void 0, function* () {
        const { organizations } = context.assets;
        if (!organizations)
            return { organizations: null };
        return {
            organizations,
        };
    });
}
function dump(context) {
    return __awaiter(this, void 0, void 0, function* () {
        const { organizations } = context.assets;
        if (!organizations)
            return { organizations: null };
        return {
            organizations: organizations.map((org) => {
                if (org.connections.length > 0) {
                    org.connections = org.connections.map((c) => {
                        // connection is a computed field
                        const name = c.connection && c.connection.name;
                        delete c.connection_id;
                        delete c.connection;
                        return Object.assign({ name }, c);
                    });
                }
                return org;
            }),
        };
    });
}
const organizationsHandler = {
    parse,
    dump,
};
exports.default = organizationsHandler;
//# sourceMappingURL=organizations.js.map