"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = __importDefault(require("path"));
const fs_extra_1 = __importDefault(require("fs-extra"));
const logger_1 = __importDefault(require("../../../logger"));
function parse(context) {
    return __awaiter(this, void 0, void 0, function* () {
        // Load the HTML file for each page
        const { pages } = context.assets;
        if (!pages)
            return { pages: null };
        return {
            pages: [
                ...pages.map((page) => (Object.assign(Object.assign({}, page), { html: page.html ? context.loadFile(page.html) : '' }))),
            ],
        };
    });
}
function dump(context) {
    return __awaiter(this, void 0, void 0, function* () {
        let pages = context.assets.pages;
        if (!pages) {
            return { pages: null };
        }
        const pagesFolder = path_1.default.join(context.basePath, 'pages');
        fs_extra_1.default.ensureDirSync(pagesFolder);
        pages = pages.map((page) => {
            if (page.html === undefined) {
                return page;
            }
            const htmlFile = path_1.default.join(pagesFolder, `${page.name}.html`);
            logger_1.default.info(`Writing ${htmlFile}`);
            fs_extra_1.default.writeFileSync(htmlFile, page.html);
            return Object.assign(Object.assign({}, page), { html: `./pages/${page.name}.html` });
        });
        return { pages };
    });
}
const pagesHandler = {
    parse,
    dump,
};
exports.default = pagesHandler;
//# sourceMappingURL=pages.js.map