"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const defaults_1 = require("../../defaults");
function parse(context) {
    return __awaiter(this, void 0, void 0, function* () {
        const { phoneProviders } = context.assets;
        if (!phoneProviders)
            return { phoneProviders: null };
        return {
            phoneProviders,
        };
    });
}
function dump(context) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!context.assets.phoneProviders)
            return { phoneProviders: null };
        let { phoneProviders } = context.assets;
        phoneProviders = phoneProviders.map((provider) => {
            provider = (0, defaults_1.phoneProviderDefaults)(provider);
            return provider;
        });
        return {
            phoneProviders,
        };
    });
}
const phoneProviderHandler = {
    parse,
    dump,
};
exports.default = phoneProviderHandler;
//# sourceMappingURL=phoneProvider.js.map