"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
function parse(context) {
    return __awaiter(this, void 0, void 0, function* () {
        const { selfServiceProfiles } = context.assets;
        if (!selfServiceProfiles)
            return { selfServiceProfiles: null };
        return {
            selfServiceProfiles,
        };
    });
}
function dump(context) {
    return __awaiter(this, void 0, void 0, function* () {
        let { selfServiceProfiles } = context.assets;
        if (!selfServiceProfiles)
            return { selfServiceProfiles: null };
        selfServiceProfiles = selfServiceProfiles.map((profile) => {
            if ('created_at' in profile) {
                delete profile.created_at;
            }
            if ('updated_at' in profile) {
                delete profile.updated_at;
            }
            return Object.assign({}, profile);
        });
        return {
            selfServiceProfiles,
        };
    });
}
const selfServiceProfileHandler = {
    parse,
    dump,
};
exports.default = selfServiceProfileHandler;
//# sourceMappingURL=selfServiceProfiles.js.map