"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const winston_1 = require("winston");
const { combine, timestamp, colorize } = winston_1.format;
const logger = (0, winston_1.createLogger)({
    level: process.env.AUTH0_LOG || 'info',
    format: combine(colorize(), timestamp(), winston_1.format.printf((info) => `${info.timestamp} - ${info.level}: ${info.message}`)),
    transports: [new winston_1.transports.Console()],
    exitOnError: false,
});
exports.default = logger;
//# sourceMappingURL=logger.js.map