import { Assets } from '../../../types';
import DefaultAPIHandler from './default';
export declare const schema: {
    type: string;
    items: {
        type: string;
        properties: {
            name: {
                type: string;
                minLength: number;
                pattern: string;
            };
            mobile: {
                type: string;
                properties: {
                    android: {
                        type: string;
                        properties: {
                            app_package_name: {
                                type: string;
                            };
                            sha256_cert_fingerprints: {
                                type: string;
                                items: {
                                    type: string;
                                };
                            };
                        };
                    };
                    ios: {
                        type: string;
                        properties: {
                            team_id: {
                                type: string;
                            };
                            app_bundle_identifier: {
                                type: string;
                            };
                        };
                    };
                };
            };
            native_social_login: {
                type: string;
                properties: {
                    apple: {
                        type: string;
                        properties: {
                            enabled: {
                                type: string;
                            };
                        };
                    };
                    facebook: {
                        type: string;
                        properties: {
                            enabled: {
                                type: string;
                            };
                        };
                    };
                    google: {
                        type: string;
                        properties: {
                            enabled: {
                                type: string;
                            };
                        };
                    };
                };
            };
            refresh_token: {
                type: string[];
                description: string;
                properties: {
                    policies: {
                        type: string[];
                        description: string;
                        items: {
                            type: string;
                            properties: {
                                audience: {
                                    type: string;
                                };
                                scope: {
                                    type: string;
                                    items: {
                                        type: string;
                                    };
                                    uniqueItems: boolean;
                                };
                            };
                            required: string[];
                        };
                    };
                };
            };
        };
        required: string[];
    };
};
export type Client = {
    client_id: string;
    name: string;
    custom_login_page?: string;
    custom_login_page_on?: boolean;
};
export default class ClientHandler extends DefaultAPIHandler {
    existing: Client[];
    constructor(config: DefaultAPIHandler);
    objString(item: any): string;
    processChanges(assets: Assets): Promise<void>;
    getType(): Promise<Client[]>;
}
