import DefaultAPIHandler from './default';
import { CalculatedChanges, Asset, Assets } from '../../../types';
import { ConfigFunction } from '../../../configFactory';
import ScimHandler from './scimHandler';
export declare const schema: {
    type: string;
    items: {
        type: string;
        properties: {
            name: {
                type: string;
            };
            strategy: {
                type: string;
            };
            options: {
                type: string;
            };
            enabled_clients: {
                type: string;
                items: {
                    type: string;
                };
            };
            realms: {
                type: string;
                items: {
                    type: string;
                };
            };
            metadata: {
                type: string;
            };
            scim_configuration: {
                type: string;
                properties: {
                    connection_name: {
                        type: string;
                    };
                    mapping: {
                        type: string;
                        items: {
                            type: string;
                            properties: {
                                scim: {
                                    type: string;
                                };
                                auth0: {
                                    type: string;
                                };
                            };
                        };
                    };
                    user_id_attribute: {
                        type: string;
                    };
                };
                required: string[];
            };
        };
        required: string[];
    };
};
export declare const addExcludedConnectionPropertiesToChanges: ({ proposedChanges, existingConnections, config, }: {
    proposedChanges: CalculatedChanges;
    existingConnections: Asset[];
    config: ConfigFunction;
}) => CalculatedChanges | {
    update: {
        options: any;
    }[];
    del: Asset[];
    conflicts: Asset[];
    create: Asset[];
};
export default class ConnectionsHandler extends DefaultAPIHandler {
    existing: Asset[] | null;
    scimHandler: ScimHandler;
    constructor(config: DefaultAPIHandler);
    objString(connection: any): string;
    getFormattedOptions(connection: any, clients: any): {
        options: any;
    } | {
        options?: undefined;
    };
    getType(): Promise<Asset[] | null>;
    calcChanges(assets: Assets): Promise<CalculatedChanges>;
    processChanges(assets: Assets): Promise<void>;
}
