import DefaultAPIHandler from './default';
import { CalculatedChanges, Assets } from '../../../types';
export declare const schema: {
    type: string;
    items: {
        type: string;
        properties: {
            strategy: {
                type: string;
                enum: string[];
                default: string;
            };
            name: {
                type: string;
            };
            options: {
                type: string;
                properties: {
                    customScripts: {
                        type: string;
                        properties: {};
                    };
                    attributes: {
                        type: string;
                        properties: {
                            email: {
                                type: string;
                                properties: {
                                    identifier: {
                                        type: string;
                                        properties: {
                                            active: {
                                                type: string;
                                            };
                                        };
                                    };
                                    profile_required: {
                                        type: string;
                                    };
                                    verification_method: {
                                        type: string;
                                        enum: string[];
                                    };
                                    signup: {
                                        type: string;
                                        properties: {
                                            status: {
                                                type: string;
                                                enum: string[];
                                            };
                                            verification: {
                                                type: string;
                                                properties: {
                                                    active: {
                                                        type: string;
                                                    };
                                                };
                                            };
                                        };
                                    };
                                };
                            };
                            phone_number: {
                                type: string;
                                properties: {
                                    identifier: {
                                        type: string;
                                        properties: {
                                            active: {
                                                type: string;
                                            };
                                        };
                                    };
                                    profile_required: {
                                        type: string;
                                    };
                                    signup: {
                                        type: string;
                                        properties: {
                                            status: {
                                                type: string;
                                                enum: string[];
                                            };
                                            verification: {
                                                type: string;
                                                properties: {
                                                    active: {
                                                        type: string;
                                                    };
                                                };
                                            };
                                        };
                                    };
                                };
                            };
                            username: {
                                type: string;
                                properties: {
                                    identifier: {
                                        type: string;
                                        properties: {
                                            active: {
                                                type: string;
                                            };
                                        };
                                    };
                                    profile_required: {
                                        type: string;
                                    };
                                    signup: {
                                        type: string;
                                        properties: {
                                            status: {
                                                type: string;
                                                enum: string[];
                                            };
                                        };
                                    };
                                };
                            };
                        };
                    };
                };
            };
        };
        required: string[];
    };
};
export default class DatabaseHandler extends DefaultAPIHandler {
    constructor(config: DefaultAPIHandler);
    objString(db: any): string;
    getClientFN(fn: 'create' | 'delete' | 'getAll' | 'update'): Function;
    getType(): Promise<import("../../../types").Asset | import("../../../types").Asset[]>;
    calcChanges(assets: Assets): Promise<CalculatedChanges>;
    processChanges(assets: Assets): Promise<void>;
}
