import { GetFlowsVaultConnections200ResponseOneOfInner } from 'auth0';
import DefaultHandler from './default';
import { Asset, Assets, CalculatedChanges } from '../../../types';
export type FlowVaultConnection = {
    name: string;
    app_id: string;
    environment: string;
    setup: object;
    account_name: string;
    ready: string;
};
export declare const schema: {
    type: string;
    items: {
        type: string;
        properties: {
            name: {
                type: string;
            };
            app_id: {
                type: string;
                enum: string[];
            };
            environment: {
                type: string;
            };
            setup: {
                type: string;
            };
            account_name: {
                type: string;
            };
            ready: {
                type: string;
            };
        };
        required: string[];
    };
    additionalProperties: boolean;
};
export default class FlowVaultHandler extends DefaultHandler {
    existing: Asset;
    constructor(options: DefaultHandler);
    getType(): Promise<Asset>;
    processChanges(assets: Assets): Promise<void>;
    getAllFlowConnections(): Promise<GetFlowsVaultConnections200ResponseOneOfInner[]>;
    createVaultConnection(conn: any): Promise<Asset>;
    createVaultConnections(creates: CalculatedChanges['create']): Promise<void>;
    updateVaultConnection(conn: any): Promise<import("auth0").ApiResponse<import("auth0").PostFlowsVaultConnections201Response>>;
    updateVaultConnections(updates: CalculatedChanges['update']): Promise<void>;
    deleteVaultConnection(conn: any): Promise<void>;
    deleteVaultConnections(data: Asset[]): Promise<void>;
}
