"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.schema = void 0;
const dot_prop_1 = __importDefault(require("dot-prop"));
const default_1 = __importStar(require("./default"));
const logger_1 = __importDefault(require("../../../logger"));
const client_1 = require("../client");
const utils_1 = require("../../../utils");
exports.schema = {
    type: 'array',
    items: {
        type: 'object',
        properties: {
            name: { type: 'string' },
            body: { type: 'string' },
        },
        required: ['name'],
    },
    additionalProperties: false,
};
class FormsHandler extends default_1.default {
    constructor(options) {
        super(Object.assign(Object.assign({}, options), { type: 'forms', id: 'id', stripCreateFields: ['created_at', 'updated_at', 'submitted_at', 'embedded_at'], stripUpdateFields: ['created_at', 'updated_at', 'submitted_at', 'embedded_at'] }));
    }
    getType() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.existing) {
                return this.existing;
            }
            const [forms, flows] = yield Promise.all([
                (0, client_1.paginate)(this.client.forms.getAll, {
                    paginate: true,
                    include_totals: true,
                }),
                (0, client_1.paginate)(this.client.flows.getAll, {
                    paginate: true,
                    include_totals: true,
                }),
            ]);
            // get more details for each form
            const allForms = yield Promise.all(forms.map((from) => __awaiter(this, void 0, void 0, function* () {
                const { data: form } = yield this.client.forms.get({ id: from.id });
                return form;
            })));
            // create a map for id to name from allFlows
            const flowIdMap = {};
            flows.forEach((f) => {
                flowIdMap[f.id] = f.name;
            });
            this.existing = yield this.formateFormFlowId(allForms, flowIdMap);
            return this.existing;
        });
    }
    formateFormFlowId(forms, flowIdMap) {
        return __awaiter(this, void 0, void 0, function* () {
            // replace flow_id with flow names
            yield Promise.all(forms.map((form) => __awaiter(this, void 0, void 0, function* () {
                const flows = (0, utils_1.findKeyPathWithValue)(form, 'flow_id');
                yield Promise.all(flows.map((f) => __awaiter(this, void 0, void 0, function* () {
                    const flowId = (dot_prop_1.default.get(form, f.path) || '');
                    const flowName = flowIdMap[flowId];
                    if (!flowName) {
                        logger_1.default.warn(`Flow: ${flowId} not found for form:${form.name}, please verify the flow id.`);
                    }
                    else {
                        dot_prop_1.default.set(form, f.path, flowName);
                    }
                })));
                return form;
            })));
            return forms;
        });
    }
    pargeFormFlowName(forms, flowNameMap) {
        return __awaiter(this, void 0, void 0, function* () {
            // replace flow names with flow_id
            yield Promise.all(forms.map((form) => __awaiter(this, void 0, void 0, function* () {
                const flows = (0, utils_1.findKeyPathWithValue)(form, 'flow_id');
                yield Promise.all(flows.map((f) => __awaiter(this, void 0, void 0, function* () {
                    const flowName = (dot_prop_1.default.get(form, f.path) || '');
                    const flowId = flowNameMap[flowName];
                    if (!flowId) {
                        logger_1.default.error(`Flow: ${flowName} not found for form:${form.name}, please verify the flow name.`);
                    }
                    else {
                        dot_prop_1.default.set(form, f.path, flowNameMap[flowName]);
                    }
                })));
                return form;
            })));
            return forms;
        });
    }
    processChanges(assets) {
        const _super = Object.create(null, {
            processChanges: { get: () => super.processChanges }
        });
        return __awaiter(this, void 0, void 0, function* () {
            const { forms } = assets;
            // Do nothing if not set
            if (!forms)
                return;
            const flows = yield (0, client_1.paginate)(this.client.flows.getAll, {
                paginate: true,
                include_totals: true,
            });
            // create a map for id to name from flows
            const flowNamMap = {};
            flows.forEach((f) => {
                flowNamMap[f.name] = f.id;
            });
            assets.forms = yield this.pargeFormFlowName(forms, flowNamMap);
            const { del, update, create, conflicts } = yield this.calcChanges(assets);
            const changes = {
                del: del,
                update: update,
                create: create,
                conflicts: conflicts,
            };
            yield _super.processChanges.call(this, assets, Object.assign({}, changes));
        });
    }
}
exports.default = FormsHandler;
__decorate([
    (0, default_1.order)('70')
], FormsHandler.prototype, "processChanges", null);
//# sourceMappingURL=forms.js.map