import DefaultHandler from './default';
import { Asset, Assets, CalculatedChanges } from '../../../types';
export declare const excludeSchema: {
    type: string;
    items: {
        type: string;
    };
};
export declare const schema: {
    type: string;
    items: {
        type: string;
        default: never[];
        properties: {
            script: {
                type: string;
                description: string;
                default: string;
            };
            name: {
                type: string;
                description: string;
                pattern: string;
            };
            enabled: {
                type: string;
                description: string;
                default: boolean;
            };
            triggerId: {
                type: string;
                description: string;
                enum: string[];
            };
            secrets: {
                type: string;
                description: string;
                default: {};
            };
            dependencies: {
                type: string;
                default: {};
                description: string;
            };
        };
        required: string[];
    };
};
export default class HooksHandler extends DefaultHandler {
    existing: Asset[];
    constructor(options: DefaultHandler);
    objString(hook: any): string;
    processSecrets(hooks: any): Promise<void>;
    getType(reload: boolean): Promise<Asset[] | null>;
    calcChanges(assets: Assets): Promise<CalculatedChanges>;
    validate(assets: any): Promise<void>;
    processChanges(assets: Assets): Promise<void>;
}
