import DefaultAPIHandler from './default';
import { Asset, Assets } from '../../../types';
export declare const schema: {
    type: string;
    items: {
        type: string;
        properties: {
            id: {
                type: string;
            };
            type: {
                type: string;
            };
            name: {
                type: string;
            };
            status: {
                type: string;
                enum: string[];
            };
            sink: {
                type: string;
            };
            filters: {
                type: string;
                items: {
                    type: string;
                };
            };
        };
        required: string[];
    };
};
export type LogStream = {
    type: 'eventbridge' | 'eventgrid' | 'datadog' | 'http' | 'splunk' | 'sumo';
    name: string;
    id: string;
    status?: 'active' | 'suspended' | 'paused';
    sink?: {
        [key: string]: string | boolean;
    };
};
export default class LogStreamsHandler extends DefaultAPIHandler {
    existing: Asset[] | null;
    constructor(config: DefaultAPIHandler);
    objString(item: Asset): string;
    getType(): Promise<Asset>;
    processChanges(assets: Assets): Promise<void>;
}
