import { GetOrganizationClientGrants200ResponseOneOfInner } from 'auth0';
import DefaultHandler from './default';
import { Asset, Assets, CalculatedChanges } from '../../../types';
export declare const schema: {
    type: string;
    items: {
        type: string;
        properties: {
            name: {
                type: string;
            };
            display_name: {
                type: string;
            };
            branding: {
                type: string;
            };
            metadata: {
                type: string;
            };
            connections: {
                type: string;
                items: {
                    type: string;
                    properties: {
                        connection_id: {
                            type: string;
                        };
                        assign_membership_on_login: {
                            type: string;
                        };
                        show_as_button: {
                            type: string;
                        };
                        is_signup_enabled: {
                            type: string;
                        };
                    };
                };
            };
            client_grants: {
                type: string;
                items: {
                    type: string;
                    properties: {
                        client_id: {
                            type: string;
                        };
                    };
                };
                default: never[];
            };
        };
        required: string[];
    };
};
type FormattedClientGrants = {
    grant_id: string;
    client_id: string;
};
export default class OrganizationsHandler extends DefaultHandler {
    existing: Asset[];
    formattedClientGrants: FormattedClientGrants[];
    constructor(config: DefaultHandler);
    deleteOrganization(org: any): Promise<void>;
    deleteOrganizations(data: Asset[]): Promise<void>;
    createOrganization(org: any): Promise<Asset>;
    createOrganizations(creates: CalculatedChanges['create']): Promise<void>;
    updateOrganization(org: any, organizations: any): Promise<{
        id: any;
    }>;
    getClientGrantIDByClientName(clientsName: string): string;
    getFormattedClientGrants(): Promise<FormattedClientGrants[]>;
    updateOrganizations(updates: CalculatedChanges['update'], orgs: Asset[]): Promise<void>;
    getType(): Promise<Asset[]>;
    processChanges(assets: Assets): Promise<void>;
    getOrganizationClientGrants(organizationId: string): Promise<GetOrganizationClientGrants200ResponseOneOfInner[]>;
    createOrganizationClientGrants(organizationId: string, grantId: string): Promise<GetOrganizationClientGrants200ResponseOneOfInner>;
    deleteOrganizationClientGrants(organizationId: string, grantId: string): Promise<void>;
}
export {};
