import { ResourceServer } from 'auth0';
import DefaultHandler from './default';
import { Assets, CalculatedChanges } from '../../../types';
export declare const excludeSchema: {
    type: string;
    items: {
        type: string;
    };
};
export declare const schema: {
    type: string;
    items: {
        type: string;
        properties: {
            name: {
                type: string;
            };
            identifier: {
                type: string;
            };
            scopes: {
                type: string;
                items: {
                    type: string;
                    properties: {
                        name: {
                            type: string;
                        };
                        description: {
                            type: string;
                        };
                    };
                };
            };
            enforce_policies: {
                type: string;
            };
            token_dialect: {
                type: string;
            };
        };
        required: string[];
    };
};
export default class ResourceServersHandler extends DefaultHandler {
    existing: ResourceServer[];
    constructor(options: DefaultHandler);
    objString(resourceServer: any): string;
    getType(): Promise<ResourceServer[]>;
    calcChanges(assets: Assets): Promise<CalculatedChanges>;
    validate(assets: Assets): Promise<void>;
}
