import APIHandler from '../tools/auth0/handlers/default';
import { Asset, CalculatedChanges } from '../types';
/**
 * @template T
 * @param {typeof import('./auth0/handlers/default').default} handler
 * @param {T} desiredAssetState
 * @param {T} currentAssetState
 * @param {string[]} [objectFields=[]]
 * @param {boolean} [allowDelete]
 * @returns T
 */
export declare function processChangedObjectFields({ handler, desiredAssetState, currentAssetState, allowDelete, }: {
    handler: APIHandler;
    desiredAssetState: Asset;
    currentAssetState: Asset;
    allowDelete: boolean;
}): {
    [key: string]: any;
};
export declare function calculateChanges({ handler, assets, existing, identifiers, allowDelete, }: {
    handler: APIHandler;
    assets: Asset[];
    existing: Asset[] | null;
    identifiers: string[];
    allowDelete: boolean;
}): CalculatedChanges;
