"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = deploy;
const auth0_1 = __importDefault(require("./auth0"));
const logger_1 = __importDefault(require("../logger"));
function deploy(assets, client, config) {
    return __awaiter(this, void 0, void 0, function* () {
        // Setup log level
        logger_1.default.level = process.env.AUTH0_DEBUG === 'true' ? 'debug' : 'info';
        logger_1.default.info(`Getting access token for ${config('AUTH0_CLIENT_ID') !== undefined ? `${config('AUTH0_CLIENT_ID')}/` : ''}${config('AUTH0_DOMAIN')}`);
        const auth0 = new auth0_1.default(client, assets, config);
        // Validate Assets
        yield auth0.validate();
        // Process changes
        yield auth0.processChanges();
        return auth0.handlers.reduce((accum, h) => {
            accum[h.type] = {
                deleted: h.deleted,
                created: h.created,
                updated: h.updated,
            };
            return accum;
        }, {});
    });
}
//# sourceMappingURL=deploy.js.map