import constants from './constants';
import deploy from './deploy';
import Auth0 from './auth0';
import { keywordReplace, loadFileAndReplaceKeywords, wrapArrayReplaceMarkersInQuotes } from './utils';
declare const _default: {
    constants: {
        CONCURRENT_CALLS: number;
        RULES_DIRECTORY: string;
        RULES_STAGES: string[];
        DEFAULT_RULE_STAGE: string;
        HOOKS_HIDDEN_SECRET_VALUE: string;
        OBFUSCATED_SECRET_VALUE: string;
        HOOKS_DIRECTORY: string;
        ACTIONS_DIRECTORY: string;
        TRIGGERS_DIRECTORY: string;
        RULES_CONFIGS_DIRECTORY: string;
        PAGES_DIRECTORY: string;
        PAGE_LOGIN: string;
        PAGE_GUARDIAN_MULTIFACTOR: string;
        PAGE_PASSWORD_RESET: string;
        PAGE_ERROR: string;
        DATABASE_CONNECTIONS_DIRECTORY: string;
        DATABASE_SCRIPTS_CHANGE_EMAIL: string;
        DATABASE_SCRIPTS_GET_USER: string;
        EMAIL_TEMPLATES_TYPES: import("auth0").GetEmailTemplatesByTemplateNameTemplateNameEnum[];
        ACTIONS_TRIGGERS: string[];
        EMAIL_TEMPLATES_DIRECTORY: string;
        EMAIL_VERIFY: string;
        EMAIL_VERIFY_BY_CODE: string;
        EMAIL_RESET: string;
        EMAIL_RESET_BY_CODE: string;
        EMAIL_WELCOME: string;
        EMAIL_BLOCKED: string;
        EMAIL_STOLEN_CREDENTIALS: string;
        EMAIL_ENROLLMENT: string;
        EMAIL_CHANGE_PASSWORD: string;
        EMAIL_PASSWORD_RESET: string;
        EMAIL_MFA_OOB_CODE: string;
        EMAIL_USER_INVITATION: string;
        GUARDIAN_DIRECTORY: string;
        GUARDIAN_FACTORS_DIRECTORY: string;
        GUARDIAN_PROVIDERS_DIRECTORY: string;
        GUARDIAN_TEMPLATES_DIRECTORY: string;
        UNIVERSAL_LOGIN_TEMPLATE: string;
        RESOURCE_SERVERS_DIRECTORY: string;
        RESOURCE_SERVERS_CLIENT_NAME: string;
        RESOURCE_SERVERS_MANAGEMENT_API_NAME: string;
        RESOURCE_SERVERS_ID_NAME: string;
        CLIENTS_DIRECTORY: string;
        CLIENTS_GRANTS_DIRECTORY: string;
        BRANDING_DIRECTORY: string;
        PHONE_PROVIDER_DIRECTORY: string;
        BRANDING_TEMPLATES_DIRECTORY: string;
        BRANDING_TEMPLATES_YAML_DIRECTORY: string;
        CLIENTS_CLIENT_NAME: string;
        CLIENTS_CLIENT_ID_NAME: string;
        CONNECTIONS_DIRECTORY: string;
        CONNECTIONS_CLIENT_NAME: string;
        CONNECTIONS_ID_NAME: string;
        ROLES_DIRECTORY: string;
        ATTACK_PROTECTION_DIRECTORY: string;
        GUARDIAN_FACTORS: string[];
        GUARDIAN_POLICIES: string[];
        GUARDIAN_PHONE_PROVIDERS: string[];
        GUARDIAN_PHONE_MESSAGE_TYPES: string[];
        GUARDIAN_FACTOR_TEMPLATES: string[];
        GUARDIAN_FACTOR_PROVIDERS: {
            sms: string[];
            'push-notification': string[];
        };
        PAGE_NAMES: string[];
        DATABASE_SCRIPTS: string[];
        DATABASE_SCRIPTS_NO_IMPORT: string[];
        DATABASE_SCRIPTS_IMPORT: string[];
        EMAIL_TEMPLATES_NAMES: string[];
        SUPPORTED_BRANDING_TEMPLATES: string[];
        LOG_STREAMS_DIRECTORY: string;
        PROMPTS_DIRECTORY: string;
        PROMPTS_SCREEN_RENDER_DIRECTORY: string;
        PARTIALS_DIRECTORY: string;
        CUSTOM_DOMAINS_DIRECTORY: string;
        THEMES_DIRECTORY: string;
        CONNECTION_APP_ID: string[];
        FORMS_DIRECTORY: string;
        FLOWS_DIRECTORY: string;
        FLOWS_VAULT_DIRECTORY: string;
        SELF_SERVICE_PROFILE_DIRECTORY: string;
        NETWORK_ACLS_DIRECTORY: string;
        PROMPT_SCREEN_MAPPINGS: {
            [prompt: string]: string[];
        };
    };
    deploy: typeof deploy;
    keywordReplace: typeof keywordReplace;
    loadFileAndReplaceKeywords: typeof loadFileAndReplaceKeywords;
    wrapArrayReplaceMarkersInQuotes: typeof wrapArrayReplaceMarkersInQuotes;
    Auth0: typeof Auth0;
};
export default _default;
export { constants, deploy, keywordReplace, loadFileAndReplaceKeywords, wrapArrayReplaceMarkersInQuotes, Auth0, };
